; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - CodeGenerator.pb
; Version du fichier : 0.9.0
; Programmation : En cours
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 24-05-2018
; Code PureBasic : V5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule CodeGenerator
  
  Declare To_GUI()
  Declare From_GUI()
  Declare GadgetLinking(GadgetID, Flag)
  
  Declare Reset()
  Declare Initialize()
  Declare Refresh()
  Declare Generate(Flag.b = 0)
  Declare PastedCodeCleanUp()
  Declare SaveProjectFile(FileName.s)
  Declare LoadProjectFile(FileName.s)
  Declare SaveSourceCode(FileName.s)
  
EndDeclareModule

Module CodeGenerator
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #LineFeed = #CRLF$    
      #TwinLineFeed = #CRLF$ + #CRLF$
      
    CompilerCase #PB_OS_Linux
      #LineFeed = #LF$
      #TwinLineFeed = #LF$ + #LF$
      
    CompilerCase #PB_OS_MacOS
      #LineFeed = #CR$
      #TwinLineFeed = #CR$ + #CR$
      
  CompilerEndSelect
  
  Enumeration
    
    #METHOD_FLAG_OBSERVATOR
    #METHOD_FLAG_MUTATOR
    #METHOD_FLAG_UPDATE
    #METHOD_FLAG_INITIALIZE
    #METHOD_FLAG_RESET
    
    #METHOD_FLAG_QUICK_SORT_ASCENDING
    #METHOD_FLAG_QUICK_SORT_DESCENDING
    #METHOD_FLAG_LINEAR_SEARCH
    #METHOD_FLAG_BINARY_SEARCH
    #METHOD_FLAG_FIXED_LENGTH_QUEUE
    
    #METHOD_FLAG_SORT_LINKED_LIST
    #METHOD_FLAG_LINEAR_SEARCH_LINKED_LIST
    #METHOD_FLAG_BINARY_SEARCH_LINKED_LIST
    
    #METHOD_FLAG_SORT_DYNAMIC_ARRAY
    #METHOD_FLAG_LINEAR_SEARCH_DYNAMIC_ARRAY
    #METHOD_FLAG_BINARY_SEARCH_DYNAMIC_ARRAY
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; Mthodes avec aucun gadget associs
    
    #METHOD_FLAG_SPECIAL
    
    ; Mthodes avec aucun gadget associs
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    #METHOD_FLAG_EQUAL
    #METHOD_FLAG_PLUS
    #METHOD_FLAG_MINUS
    #METHOD_FLAG_PRODUCT
    #METHOD_FLAG_DIVIDE
    #METHOD_FLAG_ZERO
    #METHOD_FLAG_ONE
    #METHOD_FLAG_PRODUCT_BY_SCALAR
    #METHOD_FLAG_DIVIDE_BY_SCALAR
    #METHOD_FLAG_COPY
    #METHOD_FLAG_COMPARE
    #METHOD_FLAG_SWAPPING
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; Mthodes avec aucun gadget associs
    
    #METHOD_FLAG_IDENTITY
    #METHOD_FLAG_TRANSPOSE
    #METHOD_FLAG_SELF_TRANSPOSE
    #METHOD_FLAG_RANDOM
    #METHOD_FLAG_DETERMINANT
    #METHOD_FLAG_INVERSE
    #METHOD_FLAG_FORMAT
    #METHOD_FLAG_UNFORMAT
    
    ; Mthodes avec aucun gadget associs
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    #METHOD_FLAG_PREF_GROUP
    #METHOD_FLAG_PREF_FILE
    
    #METHOD_FLAG_XML_SETGET_NODE
    #METHOD_FLAG_XML_SETGET_ATTRIBUTE
    #METHOD_FLAG_XML_ADDCOLLECT_ATTRIBUTE
    #METHOD_FLAG_XML_CREATELOAD_FILE
    #METHOD_FLAG_XML_CATCH_FILE
    
    #METHOD_FLAG_JSON_CREATELOAD_FILE
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; Mthodes avec aucun gadget associs
    
    #METHOD_FLAG_DATABASE_CREATE_TABLES
    #METHOD_FLAG_DATABASE_DROP_TABLES
    #METHOD_FLAG_DATABASE_TRUNCATE_TABLES
    #METHOD_FLAG_DATABASE_SELECT_TABLES
    #METHOD_FLAG_DATABASE_COUNT_ROW_TABLES
    
    #METHOD_FLAG_DATABASE_INSERT_TABLE_ENTRY
    #METHOD_FLAG_DATABASE_INSERT_TABLES_ENTRY
    
    #METHOD_FLAG_DATABASE_UPDATE_TABLE_ENTRY
    #METHOD_FLAG_DATABASE_UPDATE_TABLES_ENTRY
    
    #METHOD_FLAG_DATABASE_DELETE_TABLE_ENTRY
    #METHOD_FLAG_DATABASE_DELETE_TABLES_ENTRY
    
    #METHOD_FLAG_DATABASE_EXTRACT_TABLE_ENTRY
    #METHOD_FLAG_DATABASE_EXTRACT_TABLES_ENTRY
    
    #METHOD_FLAG_DATABASE_TO_TABLES
    #METHOD_FLAG_DATABASE_TABLES_TO
    
    ; Mthodes avec aucun gadget associs
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    #METHOD_FLAG_DATABASE_CREATE_TABLE
    #METHOD_FLAG_DATABASE_DROP_TABLE
    #METHOD_FLAG_DATABASE_TRUNCATE_TABLE
    #METHOD_FLAG_DATABASE_SELECT_TABLE
    #METHOD_FLAG_DATABASE_COUNT_ROW_TABLE
    
    #METHOD_FLAG_DATABASE_OPEN_FILE
    #METHOD_FLAG_DATABASE_MODULE_TO
    #METHOD_FLAG_DATABASE_TO_MODULE
    #METHOD_FLAG_DATABASE_VACUUMIZE
    
    #METHOD_FLAG_BINARY_RW
    #METHOD_FLAG_BINARY_CREATE_FILE
    #METHOD_FLAG_BINARY_OPEN_FILE
    #METHOD_FLAG_BINARY_READ_FILE
    
    #METHOD_FLAG_ENCODED_RW
    #METHOD_FLAG_ENCODED_CREATE_FILE
    #METHOD_FLAG_ENCODED_OPEN_FILE
    #METHOD_FLAG_ENCODED_READ_FILE
    
    #METHOD_FLAG_CRYPTED_RW
    #METHOD_FLAG_CRYPTED_CREATE_FILE
    #METHOD_FLAG_CRYPTED_OPEN_FILE
    #METHOD_FLAG_CRYPTED_READ_FILE
    
    #METHOD_FLAG_DEBUGGING
    
    #METHOD_FLAG_MAX
    
  EndEnumeration
  
  #METHOD_IS_NOTHING = 0
  #METHOD_IS_PUBLIC = 1
  #METHOD_IS_PRIVATE = 2
  
  Enumeration
    
    #INSTANCE_UNIQUE
    #INSTANCE_MULTIPLE_ID
    #INSTANCE_MULTIPLE_INDEX
    #INSTANCE_MULTIPLE_NAME
    #INSTANCE_OFF_MODULE
    
  EndEnumeration
  
  Structure Instance
    
    FirstMethodGadget.l
    LastMethodGadget.l
    ModuleNameGadget.l
    InstanceGadget.l
    EditorGadget.l[3]
    PanelGadgetID.l[2]
    InternalStructListViewGadget.l
    XMLNodeGadget.l
    InstanceFlag.b
    ModuleName.s
    MethodFlags.a[#METHOD_FLAG_MAX]
    MethodPrefKey.s[#METHOD_FLAG_MAX]
    
  EndStructure
  
  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Section Priv <<<<<
  
  Macro IsNotBetween(Value, Lower, Upper)
    
    ((Value) < (Lower) Or (Value) > (Upper))
    
  EndMacro
  
  Procedure PrepareStep00()
    
    From_GUI()
    
    If Instance\ModuleName = ""
      MessageRequester(Language::Message("Dev-Module - Error"), Language::Message("The Module name is missing !"))
      ProcedureReturn #False
    EndIf
    
    If Comments::DateMaskCount() = 0
      MessageRequester(Language::Message("Dev-Module - Error"), Language::Message("No Date Mask !"))
      ProcedureReturn #False
    EndIf
    
    Comments::From_GUI()
    
    PastedCodeCleanUp()
    
    Field_Max = CountGadgetItems(Instance\EditorGadget[1]) - 1
    
    If Field_Max >= 0  
      SecondaryActive.b = #True
    EndIf
    
    For FieldID = 0 To Field_Max
      
      Definition.s = GetGadgetItemText(Instance\EditorGadget[1], FieldID , 0)
      
      If Definition <> ""
        Field::New(1, FieldID, Definition)
      EndIf
      
    Next
    
    Select Instance\InstanceFlag 
        
      Case #INSTANCE_UNIQUE
        Field::UpdateGeneral(Instance\ModuleName, "", Field::#INSTANCE_STYLE_UNIQUE, SecondaryActive)
        
      Case #INSTANCE_MULTIPLE_ID
        Field::UpdateGeneral(Instance\ModuleName, "P_InstanceID.l", Field::#INSTANCE_STYLE_MULTIPLE_ID, SecondaryActive)
        
      Case #INSTANCE_MULTIPLE_INDEX
        Field::UpdateGeneral(Instance\ModuleName, "P_Index.l", Field::#INSTANCE_STYLE_MULTIPLE_INDEX, SecondaryActive)
        
      Case #INSTANCE_MULTIPLE_NAME
        Field::UpdateGeneral(Instance\ModuleName, "P_Name.s", Field::#INSTANCE_STYLE_MULTIPLE_NAME, SecondaryActive)
        
      Case #INSTANCE_OFF_MODULE
        Field::UpdateGeneral(Instance\ModuleName, "*" + Instance\ModuleName + "A." + Instance\ModuleName, Field::#INSTANCE_STYLE_OFF_MODULE, SecondaryActive)
        
    EndSelect
    
    Field_Max = CountGadgetItems(Instance\EditorGadget[0]) - 1
    
    If Instance\InstanceFlag = #INSTANCE_MULTIPLE_ID
      
      For FieldID = 0 To Field_Max
        
        If GetGadgetItemText(Instance\EditorGadget[0], FieldID , 0) = "ID.l"
          ID_Field_Found = #True
          Break
        EndIf
        
      Next
      
      If ID_Field_Found = #False
        AddGadgetItem(Instance\EditorGadget[0], 0, "ID.l")
      EndIf
      
    EndIf
    
    Field_Max = CountGadgetItems(Instance\EditorGadget[0]) - 1
    
    For FieldID = 0 To Field_Max
      
      Definition.s = GetGadgetItemText(Instance\EditorGadget[0], FieldID , 0)
      
      If Definition <> ""
        Field::New(0, FieldID, Definition)
      EndIf
      
    Next
    
    Field::GenerateParamList()
    
    ProcedureReturn #True
  EndProcedure
  
  Procedure.s DeclarePublicProcedureCode()
    
    Buffer.s + "DeclareModule " + Instance\ModuleName + #TwinLineFeed
    
    If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
      Buffer + Comments::Section(Language::Message("Structure declaration"), 1)
      Buffer + Field::GenerateStructures(0)
    EndIf
    
    Buffer + Field::GenerateMultipleInstanceHelper(Field::#METHOD_MODE_DECLARE)
    
    FieldMax = Field::CountInstances() - 1
    
    For FlagID = #METHOD_FLAG_OBSERVATOR To #METHOD_FLAG_MAX - 1
      
      If Instance\MethodFlags[FlagID] = #METHOD_IS_PUBLIC
        
        Select FlagID
            
          Case #METHOD_FLAG_OBSERVATOR
            
            For FieldID = 0 To FieldMax
              Buffer + Field::MethodGetSet(FieldID, 0, Field::#METHOD_MODE_DECLARE)
            Next
            
          Case #METHOD_FLAG_MUTATOR
            
            For FieldID = 0 To FieldMax
              Buffer + Field::MethodGetSet(FieldID, 1, Field::#METHOD_MODE_DECLARE)
            Next
            
          Case #METHOD_FLAG_UPDATE
            Buffer + Field::MethodUpdate(Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_INITIALIZE
            Buffer + Field::MethodInitialize(Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_RESET
            Buffer + Field::MethodReset(Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_QUICK_SORT_ASCENDING
            Buffer + Field::MethodStaticArray(0, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_QUICK_SORT_DESCENDING
            Buffer + Field::MethodStaticArray(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_LINEAR_SEARCH
            Buffer + Field::MethodStaticArray(2, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_BINARY_SEARCH
            Buffer + Field::MethodStaticArray(3, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_FIXED_LENGTH_QUEUE
            Buffer + Field::MethodStaticArray(4, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_SORT_LINKED_LIST
            Buffer + Field::MethodLinkedList(0, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_LINEAR_SEARCH_LINKED_LIST
            Buffer + Field::MethodLinkedList(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_BINARY_SEARCH_LINKED_LIST
            Buffer + Field::MethodLinkedList(2, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_SORT_DYNAMIC_ARRAY
            Buffer + Field::MethodDynamicArray(0, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_LINEAR_SEARCH_DYNAMIC_ARRAY
            Buffer + Field::MethodDynamicArray(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_BINARY_SEARCH_DYNAMIC_ARRAY
            Buffer + Field::MethodDynamicArray(2, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_SPECIAL
            If Field::GetSpecialMethods() = #True
              Buffer + Field::MethodsSpecial(Field::#METHOD_MODE_DECLARE)
            EndIf   
            
          Case #METHOD_FLAG_EQUAL
            Buffer + Field::MethodMaths(0, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_PLUS
            Buffer + Field::MethodMaths(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_MINUS
            Buffer + Field::MethodMaths(2, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_PRODUCT
            Buffer + Field::MethodMaths(3, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DIVIDE
            Buffer + Field::MethodMaths(4, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_ZERO
            Buffer + Field::MethodMaths(5, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_ONE
            Buffer + Field::MethodMaths(6, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_PRODUCT_BY_SCALAR
            Buffer + Field::MethodMaths(7, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DIVIDE_BY_SCALAR
            Buffer + Field::MethodMaths(8, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_COPY
            Buffer + Field::MethodMaths(9, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_COMPARE
            Buffer + Field::MethodMaths(10, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_SWAPPING
            Buffer + Field::MethodMaths(11, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_IDENTITY
            Buffer + Field::MethodMaths(12, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_TRANSPOSE
            Buffer + Field::MethodMaths(13, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_SELF_TRANSPOSE
            Buffer + Field::MethodMaths(14, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_RANDOM
            Buffer + Field::MethodMaths(15, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DETERMINANT
            Buffer + Field::MethodMaths(16, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_INVERSE
            Buffer + Field::MethodMaths(17, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_FORMAT
            Buffer + Field::MethodMaths(18, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_UNFORMAT
            Buffer + Field::MethodMaths(19, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_PREF_GROUP
            Buffer + Field::MethodPrefFile(0, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodPrefFile(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_PREF_FILE
            Buffer + Field::MethodPrefFile(2, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodPrefFile(3, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_XML_SETGET_NODE
            Buffer + Field::MethodXMLFile(0, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodXMLFile(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_XML_SETGET_ATTRIBUTE
            Buffer + Field::MethodXMLFile(2, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodXMLFile(3, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_XML_ADDCOLLECT_ATTRIBUTE
            Buffer + Field::MethodXMLFile(4, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodXMLFile(5, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_XML_CREATELOAD_FILE
            Buffer + Field::MethodXMLFile(6, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodXMLFile(7, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_XML_CATCH_FILE
            Buffer + Field::MethodXMLFile(8, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_JSON_CREATELOAD_FILE
            Buffer + Field::MethodJSONFile(0, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodJSONFile(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_CREATE_TABLE
            Buffer + Field::MethodDataBase(0, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_DROP_TABLE
            Buffer + Field::MethodDataBase(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_TRUNCATE_TABLE
            Buffer + Field::MethodDataBase(2, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_SELECT_TABLE
            Buffer + Field::MethodDataBase(3, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_COUNT_ROW_TABLE
            Buffer + Field::MethodDataBase(4, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_OPEN_FILE
            Buffer + Field::MethodDataBase(5, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_MODULE_TO
            Buffer + Field::MethodDataBase(6, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_TO_MODULE
            Buffer + Field::MethodDataBase(7, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DATABASE_VACUUMIZE 
            Buffer + Field::MethodDataBase(8, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_BINARY_RW
            Buffer + Field::MethodBinaryFile(0, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodBinaryFile(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_BINARY_CREATE_FILE
            Buffer + Field::MethodBinaryFile(2, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_BINARY_OPEN_FILE
            Buffer + Field::MethodBinaryFile(3, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_BINARY_READ_FILE
            Buffer + Field::MethodBinaryFile(4, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_ENCODED_RW
            Buffer + Field::MethodEncodedFile(0, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodEncodedFile(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_ENCODED_CREATE_FILE
            Buffer + Field::MethodEncodedFile(2, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_ENCODED_OPEN_FILE
            Buffer + Field::MethodEncodedFile(3, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_ENCODED_READ_FILE
            Buffer + Field::MethodEncodedFile(4, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_CRYPTED_RW
            Buffer + Field::MethodCryptedFile(0, Field::#METHOD_MODE_DECLARE)
            Buffer + Field::MethodCryptedFile(1, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_CRYPTED_CREATE_FILE
            Buffer + Field::MethodCryptedFile(2, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_CRYPTED_OPEN_FILE
            Buffer + Field::MethodCryptedFile(3, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_CRYPTED_READ_FILE
            Buffer + Field::MethodCryptedFile(4, Field::#METHOD_MODE_DECLARE)
            
          Case #METHOD_FLAG_DEBUGGING
            Buffer + Field::MethodDebugging(0, Field::#METHOD_MODE_DECLARE)
            
        EndSelect
        
      EndIf
      
    Next
    
    Buffer + #LineFeed + "EndDeclareModule" + #TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s ModuleDefinitionCode()
    
    FieldMax = Field::CountInstances() - 1
    
    Buffer.s + "Module " + Instance\ModuleName + #TwinLineFeed
    
    If Instance\InstanceFlag <> #INSTANCE_OFF_MODULE
      
      StaticArrayCte.s = Field::GenerateStaticArraySizeConstants()
      
      If StaticArrayCte <> ""
        Buffer + Comments::Section(Language::Message("Size Array Constants"), 1)
        Buffer + StaticArrayCte + #LineFeed
      EndIf
      
      CteEnum.s = Field::GenerateEnumeration()
      
      If CteEnum <> ""
        Buffer + Comments::Section(Language::Message("Constants Enumeration"), 1)
        Buffer + CteEnum + #LineFeed
      EndIf
      
      If Field::CountStructure() = 1
        Buffer + Comments::Section(Language::Message("Structure declaration"), 1)
      Else
        Buffer + Comments::Section(Language::Message("Structures declaration"), 1)
      EndIf
      
      Buffer + Field::GenerateStructures(1)
      
    EndIf
    
    MultipleInstanceHelper.s = Field::GenerateMultipleInstanceHelper(Field::#METHOD_MODE_PROCEDURE)
    
    If MultipleInstanceHelper <> ""
      
      Buffer + Comments::Section(Language::Message("Multiple Instances Helper"), 1)
      Buffer + MultipleInstanceHelper
      
    EndIf
    
    For FlagID = #METHOD_FLAG_OBSERVATOR To #METHOD_FLAG_MAX - 1
      
      If Instance\MethodFlags[FlagID] >= #METHOD_IS_PUBLIC
        
        Select FlagID
            
          Case #METHOD_FLAG_OBSERVATOR
            
            Buffer + Comments::Section(Language::Message("The observators"), 1)
            
            For FieldID = 0 To FieldMax
              Buffer + Field::MethodGetSet(FieldID, 0, Field::#METHOD_MODE_PROCEDURE) 
            Next
            
          Case #METHOD_FLAG_MUTATOR
            
            Buffer + Comments::Section(Language::Message("The mutators"), 1)
            
            For FieldID = 0 To FieldMax
              Buffer + Field::MethodGetSet(FieldID, 1, Field::#METHOD_MODE_PROCEDURE)
            Next
            
          Case #METHOD_FLAG_UPDATE
            Buffer + Comments::Section(Language::Message("The Update operator"), 1)
            Buffer + Field::MethodUpdate(Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_INITIALIZE
            Buffer + Comments::Section(Language::Message("The Initialize operator"), 1)
            Buffer + Field::MethodInitialize(Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_RESET
            Buffer + Comments::Section(Language::Message("The Reset operator"), 1)
            Buffer + Field::MethodReset(Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_QUICK_SORT_ASCENDING
            If Field::IsStaticArray()
              Buffer + Comments::Section(Language::Message("The QuickSort Ascendant operator"), 1)
              Buffer + Field::MethodStaticArray(0, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_QUICK_SORT_DESCENDING
            If Field::IsStaticArray()
              Buffer + Comments::Section(Language::Message("The QuickSort Descendant operator"), 1)
              Buffer + Field::MethodStaticArray(1, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_LINEAR_SEARCH
            If Field::IsStaticArray()
              Buffer + Comments::Section(Language::Message("The Linear Search operator"), 1)
              Buffer + Field::MethodStaticArray(2, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_BINARY_SEARCH
            If Field::IsStaticArray()
              Buffer + Comments::Section(Language::Message("The Binary Search operator"), 1)
              Buffer + Field::MethodStaticArray(3, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_FIXED_LENGTH_QUEUE
            If Field::IsStaticArray()
              Buffer + Comments::Section(Language::Message("The InsertTopBottomOut operator"), 1)
              Buffer + Field::MethodStaticArray(4, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_SORT_LINKED_LIST
            Buffer + Comments::Section(Language::Message("The sort linked list operator(s)"), 1)
            Buffer + Field::MethodLinkedList(0, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_LINEAR_SEARCH_LINKED_LIST
            Buffer + Comments::Section(Language::Message("The linear search linked list operator(s)"), 1)
            Buffer + Field::MethodLinkedList(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_BINARY_SEARCH_LINKED_LIST
            Buffer + Comments::Section(Language::Message("The binary search linked list operator(s)"), 1)
            Buffer + Field::MethodLinkedList(2, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_SORT_DYNAMIC_ARRAY
            Buffer + Comments::Section(Language::Message("The sort dynamic array operator(s)"), 1)
            Buffer + Field::MethodDynamicArray(0, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_LINEAR_SEARCH_DYNAMIC_ARRAY
            Buffer + Comments::Section(Language::Message("The linear search dynamic array operator(s)"), 1)
            Buffer + Field::MethodDynamicArray(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_BINARY_SEARCH_DYNAMIC_ARRAY
            Buffer + Comments::Section(Language::Message("The binary learch dynamic array operator(s)"), 1)
            Buffer + Field::MethodDynamicArray(2, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_SPECIAL
            If Field::GetSpecialMethods() = #True
              Buffer + Comments::Section(Language::Message("The Special operator(s)"), 1)
              Buffer + Field::MethodsSpecial(Field::#METHOD_MODE_PROCEDURE)
            EndIf   
            
          Case #METHOD_FLAG_EQUAL
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Equal operator : A = B"), 1)
              Buffer + Field::MethodMaths(0, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_PLUS
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Plus operator : R = A + B"), 1)
              Buffer + Field::MethodMaths(1, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_MINUS
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Minus operator : R = A - B"), 1)
              Buffer + Field::MethodMaths(2, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_PRODUCT
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Product operator : R = A * B"), 1)
              Buffer + Field::MethodMaths(3, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DIVIDE
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Divide operator : R = A / B"), 1)
              Buffer + Field::MethodMaths(4, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_ZERO
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Zero operator"), 1)
              Buffer + Field::MethodMaths(5, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_ONE
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The One operator"), 1)
              Buffer + Field::MethodMaths(6, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_PRODUCT_BY_SCALAR
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The ProductByScalar operator : R = A * Scalar"), 1)
              Buffer + Field::MethodMaths(7, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DIVIDE_BY_SCALAR
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The DivideByScalar operator : R = A / Scalar"), 1)
              Buffer + Field::MethodMaths(8, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_COPY
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Copy operator : A = Source : B = Destination"), 1)
              Buffer + Field::MethodMaths(9, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_COMPARE
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Compare operator"), 1)
              Buffer + Field::MethodMaths(10, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_SWAPPING
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE
              Buffer + Comments::Section(Language::Message("The Swapping operator"), 1)
              Buffer + Field::MethodMaths(11, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_IDENTITY
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE And Field::IsSquareMatrix()
              Buffer + Comments::Section(Language::Message("The Identity operator"), 1)
              Buffer + Field::MethodMaths(12, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_TRANSPOSE
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE And Field::IsSquareMatrix()
              Buffer + Comments::Section(Language::Message("The Transpose operator"), 1)
              Buffer + Field::MethodMaths(13, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_SELF_TRANSPOSE
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE And Field::IsSquareMatrix()
              Buffer + Comments::Section(Language::Message("The SelfTranspose operator"), 1)
              Buffer + Field::MethodMaths(14, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_RANDOM
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE And Field::IsMatrix()
              Buffer + Comments::Section(Language::Message("The Random operator"), 1)
              Buffer + Field::MethodMaths(15, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DETERMINANT
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE And Field::IsSquareMatrix()
              Buffer + Comments::Section(Language::Message("The Determinant operator"), 1)
              Buffer + Field::MethodMaths(16, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_INVERSE
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE And Field::IsSquareMatrix()
              Buffer + Comments::Section(Language::Message("The Inverse operator"), 1)
              Buffer + Field::MethodMaths(17, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_FORMAT
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE And Field::IsMatrix()
              Buffer + Comments::Section(Language::Message("The Format operators"), 1)
              Buffer + Field::MethodMaths(18, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_UNFORMAT
            If Instance\InstanceFlag = #INSTANCE_OFF_MODULE And Field::IsMatrix()
              Buffer + Comments::Section(Language::Message("The Unformat operators"), 1)
              Buffer + Field::MethodMaths(19, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_PREF_GROUP
            Buffer + Comments::Section(Language::Message("Read preferences group"), 1)
            Buffer + Field::MethodPrefFile(0, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Write preferences group"), 1)
            Buffer + Field::MethodPrefFile(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_PREF_FILE
            Buffer + Comments::Section(Language::Message("Create preferences file"), 1)
            Buffer + Field::MethodPrefFile(2, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Open preferences file"), 1) 
            Buffer + Field::MethodPrefFile(3, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_XML_SETGET_NODE
            Buffer + Comments::Section(Language::Message("Set - Node with child nodes"), 1) 
            Buffer + Field::MethodXMLFile(0, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Get - Node with child nodes"), 1) 
            Buffer + Field::MethodXMLFile(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_XML_SETGET_ATTRIBUTE
            Buffer + Comments::Section(Language::Message("Set - Node with attributes"), 1) 
            Buffer + Field::MethodXMLFile(2, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Get - Node with attributes"), 1) 
            Buffer + Field::MethodXMLFile(3, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_XML_ADDCOLLECT_ATTRIBUTE
            Buffer + Comments::Section(Language::Message("Add attributes to current node"), 1) 
            Buffer + Field::MethodXMLFile(4, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Collect attributes from current node"), 1) 
            Buffer + Field::MethodXMLFile(5, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_XML_CREATELOAD_FILE
            Buffer + Comments::Section(Language::Message("Create XML file"), 1) 
            Buffer + Field::MethodXMLFile(6, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Load XML file"), 1) 
            Buffer + Field::MethodXMLFile(7, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_XML_CATCH_FILE
            Buffer + Comments::Section(Language::Message("Catch XML file"), 1) 
            Buffer + Field::MethodXMLFile(8, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_JSON_CREATELOAD_FILE
            Buffer + Comments::Section(Language::Message("Create JSON file"), 1) 
            Buffer + Field::MethodJSONFile(0, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Load JSON file"), 1) 
            Buffer + Field::MethodJSONFile(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_CREATE_TABLE
            Buffer + Comments::Section(Language::Message("Create Database table"), 1) 
            Buffer + Field::MethodDataBase(0, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_CREATE_TABLES
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Create Database table(s)"), 1) 
              Buffer + Field::MethodDataBase(9, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DATABASE_DROP_TABLE
            Buffer + Comments::Section(Language::Message("Drop Database table"), 1) 
            Buffer + Field::MethodDataBase(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_DROP_TABLES
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Drop Database table(s)"), 1) 
              Buffer + Field::MethodDataBase(1, Field::#METHOD_MODE_PROCEDURE)
            EndIf 
            
          Case #METHOD_FLAG_DATABASE_TRUNCATE_TABLE
            Buffer + Comments::Section(Language::Message("Truncate Database table"), 1) 
            Buffer + Field::MethodDataBase(2, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_TRUNCATE_TABLES
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Truncate Database table(s)"), 1) 
              Buffer + Field::MethodDataBase(2, Field::#METHOD_MODE_PROCEDURE)
            EndIf 
            
          Case #METHOD_FLAG_DATABASE_SELECT_TABLE
            Buffer + Comments::Section(Language::Message("Select Database table"), 1) 
            Buffer + Field::MethodDataBase(3, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_SELECT_TABLES
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Select Database table(s)"), 1) 
              Buffer + Field::MethodDataBase(3, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DATABASE_COUNT_ROW_TABLE
            Buffer + Comments::Section(Language::Message("Count Row In Database table"), 1) 
            Buffer + Field::MethodDataBase(4, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_COUNT_ROW_TABLES
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Count Row In Database table(s)"), 1) 
              Buffer + Field::MethodDataBase(4, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DATABASE_INSERT_TABLE_ENTRY
            If Field::IsDatabaseHelperNeeded() = 2
              Buffer + Comments::Section(Language::Message("Insert Database Table entry"), 1) 
              Buffer + Field::MethodDataBase(10, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DATABASE_INSERT_TABLES_ENTRY
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Insert Database Table(s) entry"), 1) 
              Buffer + Field::MethodDataBase(10, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DATABASE_UPDATE_TABLE_ENTRY
            If Field::IsDatabaseHelperNeeded() = 2
              Buffer + Comments::Section(Language::Message("Update Database Table entry"), 1) 
              Buffer + Field::MethodDataBase(11, Field::#METHOD_MODE_PROCEDURE)
            EndIf 
            
          Case #METHOD_FLAG_DATABASE_UPDATE_TABLES_ENTRY
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Update Database Table(s) entry"), 1) 
              Buffer + Field::MethodDataBase(11, Field::#METHOD_MODE_PROCEDURE)  
            EndIf
            
          Case #METHOD_FLAG_DATABASE_DELETE_TABLE_ENTRY
            If Field::IsDatabaseHelperNeeded() = 2
              Buffer + Comments::Section(Language::Message("Delete Database Table entry"), 1) 
              Buffer + Field::MethodDataBase(12, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DATABASE_DELETE_TABLES_ENTRY
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Delete Database Table(s) entry"), 1) 
              Buffer + Field::MethodDataBase(12, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DATABASE_EXTRACT_TABLE_ENTRY
            If Field::IsDatabaseHelperNeeded() = 2
              Buffer + Comments::Section(Language::Message("Extract Database Table entry"), 1) 
              Buffer + Field::MethodDataBase(13, Field::#METHOD_MODE_PROCEDURE)
            EndIf
            
          Case #METHOD_FLAG_DATABASE_EXTRACT_TABLES_ENTRY
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Extract Database Table(s) entry"), 1) 
              Buffer + Field::MethodDataBase(13, Field::#METHOD_MODE_PROCEDURE) 
            EndIf
            
          Case #METHOD_FLAG_DATABASE_TO_TABLES
            If Field::IsDatabaseHelperNeeded() = 1
              Buffer + Comments::Section(Language::Message("Transfer Database To Table(s)"), 1) 
              Buffer + Field::MethodDataBase(14, Field::#METHOD_MODE_PROCEDURE) 
            EndIf
            
          Case #METHOD_FLAG_DATABASE_TABLES_TO
            If Field::IsDatabaseHelperNeeded() = 1 
              Buffer + Comments::Section(Language::Message("Transfer Table(s) To Database"), 1) 
              Buffer + Field::MethodDataBase(15, Field::#METHOD_MODE_PROCEDURE) 
            EndIf
            
          Case #METHOD_FLAG_DATABASE_OPEN_FILE
            Buffer + Comments::Section(Language::Message("Open Database"), 1) 
            Buffer + Field::MethodDataBase(5, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_MODULE_TO
            Buffer + Comments::Section(Language::Message("Transfer from Module to Database"), 1) 
            Buffer + Field::MethodDataBase(6, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_TO_MODULE
            Buffer + Comments::Section(Language::Message("Transfer from Database to Module"), 1) 
            Buffer + Field::MethodDataBase(7, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DATABASE_VACUUMIZE    
            Buffer + Comments::Section(Language::Message("Vacuumize Database"), 1) 
            Buffer + Field::MethodDataBase(8, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_BINARY_RW
            Buffer + Comments::Section(Language::Message("Read in Binary file"), 1)
            Buffer + Field::MethodBinaryFile(0, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Write in Binary file"), 1) 
            Buffer + Field::MethodBinaryFile(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_BINARY_CREATE_FILE 
            Buffer + Comments::Section(Language::Message("Create Binary File"), 1)
            Buffer + Field::MethodBinaryFile(2, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_BINARY_OPEN_FILE
            Buffer + Comments::Section(Language::Message("Open Binary File"), 1)
            Buffer + Field::MethodBinaryFile(3, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_BINARY_READ_FILE
            Buffer + Comments::Section(Language::Message("Read Binary File"), 1)
            Buffer + Field::MethodBinaryFile(4, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_ENCODED_RW
            Buffer + Comments::Section(Language::Message("Read in Encoded file"), 1)
            Buffer + Field::MethodEncodedFile(0, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Write in Encoded file"), 1) 
            Buffer + Field::MethodEncodedFile(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_ENCODED_CREATE_FILE 
            Buffer + Comments::Section(Language::Message("Create Encoded File"), 1)
            Buffer + Field::MethodEncodedFile(2, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_ENCODED_OPEN_FILE
            Buffer + Comments::Section(Language::Message("Open Encoded File"), 1)
            Buffer + Field::MethodEncodedFile(3, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_ENCODED_READ_FILE
            Buffer + Comments::Section(Language::Message("Read Encoded File"), 1)
            Buffer + Field::MethodEncodedFile(4, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_CRYPTED_RW
            Buffer + Comments::Section(Language::Message("Read in Crypted file"), 1)
            Buffer + Field::MethodCryptedFile(0, Field::#METHOD_MODE_PROCEDURE)
            Buffer + Comments::Section(Language::Message("Write in Crypted file"), 1) 
            Buffer + Field::MethodCryptedFile(1, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_CRYPTED_CREATE_FILE 
            Buffer + Comments::Section(Language::Message("Create Crypted File"), 1)
            Buffer + Field::MethodCryptedFile(2, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_CRYPTED_OPEN_FILE
            Buffer + Comments::Section(Language::Message("Open Crypted File"), 1)
            Buffer + Field::MethodCryptedFile(3, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_CRYPTED_READ_FILE
            Buffer + Comments::Section(Language::Message("Read Crypted File"), 1)
            Buffer + Field::MethodCryptedFile(4, Field::#METHOD_MODE_PROCEDURE)
            
          Case #METHOD_FLAG_DEBUGGING
            Buffer + Comments::Section(Language::Message("The Debugging Operator"), 1)
            Buffer + Field::MethodDebugging(0, Field::#METHOD_MODE_PROCEDURE)
            
        EndSelect
        
      EndIf
      
    Next
    
    Buffer + "EndModule" + #TwinLineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Section Publique <<<<<
  
  Procedure To_GUI()
    
    SetGadgetText(Instance\ModuleNameGadget, Instance\ModuleName)
    
    Select Instance\InstanceFlag
        
      Case #INSTANCE_UNIQUE
        SetGadgetState(Instance\InstanceGadget, 1)
        
      Case #INSTANCE_MULTIPLE_ID
        SetGadgetState(Instance\InstanceGadget + 1, 1)  
        
      Case #INSTANCE_MULTIPLE_INDEX
        SetGadgetState(Instance\InstanceGadget + 2, 1)   
        
      Case #INSTANCE_MULTIPLE_NAME
        SetGadgetState(Instance\InstanceGadget + 3, 1)   
        
      Case #INSTANCE_OFF_MODULE
        SetGadgetState(Instance\InstanceGadget + 4, 1) 
        
    EndSelect
    
    MethodID = #METHOD_FLAG_OBSERVATOR
    
    For GadgetID = Instance\FirstMethodGadget To Instance\LastMethodGadget Step 3
      
      Select Instance\MethodFlags[MethodID]
          
        Case #METHOD_IS_NOTHING
          SetGadgetState(GadgetID, 0)
          SetGadgetState(GadgetID + 1, 1)
          DisableGadget(GadgetID + 1, 1)
          DisableGadget(GadgetID + 2, 1)
          
        Case #METHOD_IS_PUBLIC
          SetGadgetState(GadgetID, 1)
          SetGadgetState(GadgetID + 1, 1)
          DisableGadget(GadgetID + 1, 0)
          DisableGadget(GadgetID + 2, 0)
          
        Case #METHOD_IS_PRIVATE
          SetGadgetState(GadgetID, 1)
          SetGadgetState(GadgetID + 2, 1)
          DisableGadget(GadgetID + 1, 0)
          DisableGadget(GadgetID + 2, 0)
          
      EndSelect
      
      MethodID = MethodID + 1
      
      If MethodID = #METHOD_FLAG_IDENTITY
        MethodID = #METHOD_FLAG_UNFORMAT + 1
      ElseIf MethodID = #METHOD_FLAG_DATABASE_CREATE_TABLES
        MethodID = #METHOD_FLAG_DATABASE_TABLES_TO + 1
      ElseIf MethodID = #METHOD_FLAG_SPECIAL
        MethodID = MethodID + 1
      EndIf
      
    Next
    
    Field::To_GUI()
    
  EndProcedure
  
  Procedure From_GUI()
    
    Instance\ModuleName = Trim(GetGadgetText(Instance\ModuleNameGadget))
    
    If GetGadgetState(Instance\InstanceGadget) = 1
      Instance\InstanceFlag = #INSTANCE_UNIQUE
    ElseIf GetGadgetState(Instance\InstanceGadget + 1) = 1
      Instance\InstanceFlag = #INSTANCE_MULTIPLE_ID
    ElseIf GetGadgetState(Instance\InstanceGadget + 2) = 1
      Instance\InstanceFlag = #INSTANCE_MULTIPLE_INDEX
    ElseIf GetGadgetState(Instance\InstanceGadget + 3) = 1
      Instance\InstanceFlag = #INSTANCE_MULTIPLE_NAME      
    ElseIf GetGadgetState(Instance\InstanceGadget + 4) = 1
      Instance\InstanceFlag = #INSTANCE_OFF_MODULE
    EndIf
    
    MethodID = #METHOD_FLAG_OBSERVATOR
    
    For GadgetID = Instance\FirstMethodGadget To Instance\LastMethodGadget Step 3
      
      If GetGadgetState(GadgetID) = 1
        If GetGadgetState(GadgetID + 1) = 1
          Instance\MethodFlags[MethodID] = #METHOD_IS_PUBLIC
        ElseIf GetGadgetState(GadgetID + 2) = 1
          Instance\MethodFlags[MethodID] = #METHOD_IS_PRIVATE
        EndIf
      Else
        Instance\MethodFlags[MethodID] = #METHOD_IS_NOTHING
      EndIf
      
      MethodID = MethodID + 1
      
      If MethodID = #METHOD_FLAG_IDENTITY
        MethodID = #METHOD_FLAG_UNFORMAT + 1
      ElseIf MethodID = #METHOD_FLAG_DATABASE_CREATE_TABLES
        MethodID = #METHOD_FLAG_DATABASE_TABLES_TO + 1
      ElseIf MethodID = #METHOD_FLAG_SPECIAL
        MethodID = MethodID + 1
      EndIf
      
    Next
    
    Instance\MethodFlags[#METHOD_FLAG_SPECIAL] = #METHOD_IS_PUBLIC
    
    For MethodID = #METHOD_FLAG_IDENTITY To #METHOD_FLAG_UNFORMAT
      Instance\MethodFlags[MethodID] = #METHOD_IS_PUBLIC
    Next
    
    For MethodID = #METHOD_FLAG_DATABASE_CREATE_TABLES To #METHOD_FLAG_DATABASE_TABLES_TO
      Instance\MethodFlags[MethodID] = #METHOD_IS_PRIVATE
    Next
    
    If Instance\MethodFlags[#METHOD_FLAG_DATABASE_MODULE_TO] And Instance\InstanceFlag = #INSTANCE_UNIQUE
      Field::IsDatabaseHelperNeeded(1) 
    ElseIf Instance\MethodFlags[#METHOD_FLAG_DATABASE_MODULE_TO] And Instance\InstanceFlag = #INSTANCE_MULTIPLE_ID
      Field::IsDatabaseHelperNeeded(2)  
    ElseIf Instance\MethodFlags[#METHOD_FLAG_DATABASE_MODULE_TO] And Instance\InstanceFlag = #INSTANCE_MULTIPLE_INDEX 
      Field::IsDatabaseHelperNeeded(2)  
    ElseIf Instance\MethodFlags[#METHOD_FLAG_DATABASE_MODULE_TO] And Instance\InstanceFlag = #INSTANCE_MULTIPLE_NAME
      Field::IsDatabaseHelperNeeded(2)
    Else
      Field::IsDatabaseHelperNeeded(0)  
    EndIf
    
    If Instance\MethodFlags[#METHOD_FLAG_XML_CREATELOAD_FILE] >= #METHOD_IS_PUBLIC
      If Instance\MethodFlags[#METHOD_FLAG_XML_SETGET_NODE] = #METHOD_IS_NOTHING
        Instance\MethodFlags[#METHOD_FLAG_XML_SETGET_NODE] = #METHOD_IS_PUBLIC
        SetGadgetState(Instance\XMLNodeGadget + 0, 1)
        SetGadgetState(Instance\XMLNodeGadget + 2, 1)
        DisableGadget(Instance\XMLNodeGadget + 1, GetGadgetState(Instance\XMLNodeGadget) ! 1)
        DisableGadget(Instance\XMLNodeGadget + 2, GetGadgetState(Instance\XMLNodeGadget) ! 1)
      EndIf
    EndIf
    
    If Instance\MethodFlags[#METHOD_FLAG_XML_CATCH_FILE] >= #METHOD_IS_PUBLIC
      If Instance\MethodFlags[#METHOD_FLAG_XML_SETGET_NODE] = #METHOD_IS_NOTHING
        Instance\MethodFlags[#METHOD_FLAG_XML_SETGET_NODE] = #METHOD_IS_PUBLIC
        SetGadgetState(Instance\XMLNodeGadget + 0, 1)
        SetGadgetState(Instance\XMLNodeGadget + 2, 1)
        DisableGadget(Instance\XMLNodeGadget + 1, GetGadgetState(Instance\XMLNodeGadget) ! 1)
        DisableGadget(Instance\XMLNodeGadget + 2, GetGadgetState(Instance\XMLNodeGadget) ! 1)
      EndIf
    EndIf 
    
    Field::From_GUI()
    
  EndProcedure
  
  Procedure GadgetLinking(GadgetID, Flag)
    
    Select Flag
        
      Case 0
        Instance\FirstMethodGadget = GadgetID
        
      Case 1
        Instance\LastMethodGadget = GadgetID
        
      Case 2
        Instance\ModuleNameGadget = GadgetID
        
      Case 3
        Instance\InstanceGadget = GadgetID
        
      Case 4
        Instance\EditorGadget[0] = GadgetID
        
      Case 5
        Instance\EditorGadget[1] = GadgetID
        
      Case 6
        Instance\EditorGadget[2] = GadgetID
        
      Case 7
        Instance\PanelGadgetID[0] = GadgetID
        
      Case 8
        Instance\PanelGadgetID[1] = GadgetID
        
      Case 9
        Instance\InternalStructListViewGadget = GadgetID 
        
      Case 10
        Instance\XMLNodeGadget = GadgetID
        
    EndSelect
    
  EndProcedure
  
  Procedure Reset()
    
    Instance\FirstMethodGadget = 0
    Instance\LastMethodGadget = 0
    Instance\ModuleNameGadget = 0
    Instance\InstanceGadget = 0
    
    For EditorID = 0 To 2
      Instance\EditorGadget[EditorID] = 0
    Next
    
    For PanelID = 0 To 1
      Instance\PanelGadgetID[PanelID] = 0  
    Next
    
    Instance\InstanceFlag = 0
    
    For MethodID = #METHOD_FLAG_OBSERVATOR To #METHOD_FLAG_MAX - 1
      Instance\MethodFlags[MethodID] = 0
      Instance\MethodPrefKey[MethodID] = ""
    Next
    
    Chrono::Reset(-1)
    
  EndProcedure
  
  Procedure Initialize()
    
    Instance\MethodPrefKey[#METHOD_FLAG_OBSERVATOR] = "Observator"
    Instance\MethodPrefKey[#METHOD_FLAG_MUTATOR] = "Mutator"
    Instance\MethodPrefKey[#METHOD_FLAG_UPDATE] = "Update"
    Instance\MethodPrefKey[#METHOD_FLAG_INITIALIZE] = "Initialize"
    Instance\MethodPrefKey[#METHOD_FLAG_RESET] = "Reset"
    
    Instance\MethodPrefKey[#METHOD_FLAG_QUICK_SORT_ASCENDING] = "QuickSortAscending"
    Instance\MethodPrefKey[#METHOD_FLAG_QUICK_SORT_DESCENDING] = "QuickSortDescending"
    Instance\MethodPrefKey[#METHOD_FLAG_LINEAR_SEARCH] = "LinearSearch"
    Instance\MethodPrefKey[#METHOD_FLAG_BINARY_SEARCH] = "BinarySearch"
    Instance\MethodPrefKey[#METHOD_FLAG_FIXED_LENGTH_QUEUE] = "FixedQueue"
    
    Instance\MethodPrefKey[#METHOD_FLAG_SORT_LINKED_LIST] = "SortLinkedList"
    Instance\MethodPrefKey[#METHOD_FLAG_LINEAR_SEARCH_LINKED_LIST] = "LinearSearchLinkedList"
    Instance\MethodPrefKey[#METHOD_FLAG_BINARY_SEARCH_LINKED_LIST] = "BinarySearchLinkedList"
    
    Instance\MethodPrefKey[#METHOD_FLAG_SORT_DYNAMIC_ARRAY] = "SortDynamicArray"
    Instance\MethodPrefKey[#METHOD_FLAG_LINEAR_SEARCH_DYNAMIC_ARRAY] = "LinearSearchDynamicArray"
    Instance\MethodPrefKey[#METHOD_FLAG_BINARY_SEARCH_DYNAMIC_ARRAY] = "BinarySearchDynamicArray"
    
    Instance\MethodPrefKey[#METHOD_FLAG_EQUAL] = "Equal"
    Instance\MethodPrefKey[#METHOD_FLAG_PLUS] = "Plus"
    Instance\MethodPrefKey[#METHOD_FLAG_MINUS] = "Minus"
    Instance\MethodPrefKey[#METHOD_FLAG_PRODUCT] = "Product"
    Instance\MethodPrefKey[#METHOD_FLAG_DIVIDE] = "Divide"
    Instance\MethodPrefKey[#METHOD_FLAG_ZERO] = "Zero"
    Instance\MethodPrefKey[#METHOD_FLAG_ONE] = "One"
    Instance\MethodPrefKey[#METHOD_FLAG_PRODUCT_BY_SCALAR] = "ProductByScalar"
    Instance\MethodPrefKey[#METHOD_FLAG_DIVIDE_BY_SCALAR] = "DivideByScalar"
    
    Instance\MethodPrefKey[#METHOD_FLAG_COPY] = "Copy"
    Instance\MethodPrefKey[#METHOD_FLAG_COMPARE] = "Compare"
    Instance\MethodPrefKey[#METHOD_FLAG_SWAPPING] = "Swapping"
    
    Instance\MethodPrefKey[#METHOD_FLAG_PREF_GROUP] = "PreferenceGroup"
    Instance\MethodPrefKey[#METHOD_FLAG_PREF_FILE] = "PreferenceFile"
    
    Instance\MethodPrefKey[#METHOD_FLAG_XML_SETGET_NODE] = "XMLNode"
    Instance\MethodPrefKey[#METHOD_FLAG_XML_SETGET_ATTRIBUTE] = "XMLAttribute"
    Instance\MethodPrefKey[#METHOD_FLAG_XML_ADDCOLLECT_ATTRIBUTE] = "XMLAddCollectAttribute"
    Instance\MethodPrefKey[#METHOD_FLAG_XML_CREATELOAD_FILE] = "XMLCreateLoadFile"
    Instance\MethodPrefKey[#METHOD_FLAG_XML_CATCH_FILE] = "XMLCatchFile"
    
    Instance\MethodPrefKey[#METHOD_FLAG_BINARY_RW] = "ReadWriteBinary"
    Instance\MethodPrefKey[#METHOD_FLAG_BINARY_CREATE_FILE] = "CreateBinaryFile"
    Instance\MethodPrefKey[#METHOD_FLAG_BINARY_OPEN_FILE] = "OpenBinaryFile"
    Instance\MethodPrefKey[#METHOD_FLAG_BINARY_READ_FILE] = "ReadBinaryFile"
    
    Instance\MethodPrefKey[#METHOD_FLAG_ENCODED_RW] = "ReadWriteEncoded"
    Instance\MethodPrefKey[#METHOD_FLAG_ENCODED_CREATE_FILE] = "CreateEncodedFile"
    Instance\MethodPrefKey[#METHOD_FLAG_ENCODED_OPEN_FILE] = "OpenEncodedFile"
    Instance\MethodPrefKey[#METHOD_FLAG_ENCODED_READ_FILE] = "ReadEncodedFile"
    
    Instance\MethodPrefKey[#METHOD_FLAG_CRYPTED_RW] = "ReadWriteCrypted"
    Instance\MethodPrefKey[#METHOD_FLAG_CRYPTED_CREATE_FILE] = "CreateCryptedFile"
    Instance\MethodPrefKey[#METHOD_FLAG_CRYPTED_OPEN_FILE] = "OpenCryptedFile"
    Instance\MethodPrefKey[#METHOD_FLAG_CRYPTED_READ_FILE] = "ReadCryptedFile"
    
    Instance\MethodPrefKey[#METHOD_FLAG_JSON_CREATELOAD_FILE] = "CreateLoadJSONFile"
    
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_CREATE_TABLE] = "CreateDataBaseTable"
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_DROP_TABLE] = "DropDataBaseTable"
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_TRUNCATE_TABLE] = "TruncateDataBaseTable"
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_SELECT_TABLE] = "SelectDataBaseTable"
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_COUNT_ROW_TABLE] = "CountRowDataBaseTable"
    
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_OPEN_FILE] = "OpenDataBaseFile"
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_MODULE_TO] = "ModuleToDatabase"
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_TO_MODULE] = "DataBaseToModule"
    Instance\MethodPrefKey[#METHOD_FLAG_DATABASE_VACUUMIZE] = "VacuumizeDataBase"
    
    Instance\MethodPrefKey[#METHOD_FLAG_DEBUGGING] = "Debugging"
    
  EndProcedure
  
  Procedure Refresh()
    
    Field::Reset(Field::#RESET_STYLE_NEW_MODULE)
    
    ClearGadgetItems(Instance\InternalStructListViewGadget)
    
    For MethodID = #METHOD_FLAG_OBSERVATOR To #METHOD_FLAG_MAX - 1
      Instance\MethodFlags[MethodID] = #METHOD_IS_NOTHING
    Next
    
    Instance\InstanceFlag = #INSTANCE_UNIQUE
    Instance\ModuleName = ""
    
    For EditorID = 0 To 2
      ClearGadgetItems(Instance\EditorGadget[EditorID])
    Next
    
    For PanelID = 0 To 1
      SetGadgetState(Instance\PanelGadgetID[PanelID], 0)
    Next
    
    To_GUI()
    
  EndProcedure
  
  Procedure Generate(Flag.b = 0)
    
    Select Flag
        
      Case 0
        
        If PrepareStep00()

          Chrono::New(0)
          Chrono::Start(0)
          
          Buffer.s = Comments::SourceHeader() + DeclarePublicProcedureCode() + ModuleDefinitionCode()
          
          Chrono::Stop(0)
          
          If Chrono::Consult(0) = 0
            Chrono::Start(0)
            Delay(1)
            Chrono::Stop(0)
          EndIf
          
          Buffer + Comments::WorkingTime(Buffer) + Comments::EndOfFile()
          
          SetGadgetText(Instance\EditorGadget[2], Buffer)
          
          Field::Reset(Field::#RESET_STYLE_AFTER_RUN)
          SetGadgetState(Instance\PanelGadgetID[0], 4)
          
        EndIf
        
      Case 1
        
        Chrono::New(0)
        Chrono::Start(0)
        
        Buffer + Comments::SourceHeader() + MatrixEncodedGenerator::GenerateSource()
        
        Chrono::Stop(0)
        
        If Chrono::Consult(0) = 0
          Chrono::Start(0)
          Delay(1)
          Chrono::Stop(0)
        EndIf
        
        Buffer + Comments::WorkingTime(Buffer) + Comments::EndOfFile()
        
        SetGadgetText(Instance\EditorGadget[2], Buffer)
        MatrixEncodedGenerator::Reset()
        SetGadgetState(Instance\PanelGadgetID[0], 4)
        
    EndSelect
    
  EndProcedure
  
  Procedure PastedCodeCleanUp()
    
    For EditorID = 0 To 2
      PastedCodeCleanUp::DoIt(Instance\EditorGadget[EditorID])
    Next
    
  EndProcedure 
  
  Procedure SaveProjectFile(FileName.s)
    
    PastedCodeCleanUp()
    From_GUI()
    
    If CreatePreferences(FileName)
      
      PreferenceGroup("ModuleDefinition")
      
      WritePreferenceString("ModuleName", Instance\ModuleName)
      WritePreferenceLong("InstanceFlag", Instance\InstanceFlag)
      
      PreferenceGroup("PrimaryField")
      
      Field_Max = CountGadgetItems(Instance\EditorGadget[0])
      
      WritePreferenceLong("Field_Max", Field_Max)
      
      For FieldID = 0 To Field_Max - 1
        
        Definition.s = GetGadgetItemText(Instance\EditorGadget[0], FieldID , 0)
        
        If Definition <> ""
          WritePreferenceString("Description_" + Str(FieldID), Definition)
        EndIf
        
      Next
      
      PreferenceGroup("SecondaryField")
      
      Field_Max = CountGadgetItems(Instance\EditorGadget[1])
      
      WritePreferenceLong("Field_Max", Field_Max)
      
      For FieldID = 0 To Field_Max - 1
        
        Definition.s = GetGadgetItemText(Instance\EditorGadget[1], FieldID , 0)
        
        If Definition <> ""
          WritePreferenceString("Description_" + Str(FieldID), Definition)
        EndIf
        
      Next
      
      Field::SaveProjectFileInternalStructure()
      
      PreferenceGroup("MethodsFlag")
      
      For FlagID = #METHOD_FLAG_OBSERVATOR To #METHOD_FLAG_MAX - 1
        
        If IsNotBetween(FlagID, #METHOD_FLAG_IDENTITY, #METHOD_FLAG_UNFORMAT) And IsNotBetween(FlagID, #METHOD_FLAG_DATABASE_CREATE_TABLES, #METHOD_FLAG_DATABASE_TABLES_TO) And FlagID <> #METHOD_FLAG_SPECIAL
          
          WritePreferenceLong(Instance\MethodPrefKey[FlagID], Instance\MethodFlags[FlagID])
          
          If FlagID = #METHOD_FLAG_ENCODED_READ_FILE
            WritePreferenceString("EncodedModuleName", Field::CurrentFileModuleName(0))
          EndIf
          
          If FlagID = #METHOD_FLAG_CRYPTED_READ_FILE
            WritePreferenceString("CryptedModuleName", Field::CurrentFileModuleName(1))
          EndIf
          
        EndIf
        
      Next
      
      ClosePreferences()
      
    EndIf
    
  EndProcedure
  
  Procedure LoadProjectFile(FileName.s)
    
    If OpenPreferences(FileName)
      
      Refresh()
      
      PreferenceGroup("ModuleDefinition")
      
      Instance\ModuleName = ReadPreferenceString("ModuleName", "")
      Instance\InstanceFlag = ReadPreferenceLong("InstanceFlag", 0)
      
      PreferenceGroup("PrimaryField")
      
      Field_Max = ReadPreferenceLong("Field_Max", 0) - 1
      
      For FieldID = 0 To Field_Max
        AddGadgetItem(Instance\EditorGadget[0], FieldID, ReadPreferenceString("Description_" + Str(FieldID), ""))
      Next
      
      PreferenceGroup("SecondaryField")
      
      Field_Max = ReadPreferenceLong("Field_Max", 0) - 1
      
      For FieldID = 0 To Field_Max
        AddGadgetItem(Instance\EditorGadget[1], FieldID, ReadPreferenceString("Description_" + Str(FieldID), ""))
      Next
      
      Field::LoadProjectFileInternalStructure()
      
      PreferenceGroup("MethodsFlag")
      
      For FlagID = #METHOD_FLAG_OBSERVATOR To #METHOD_FLAG_MAX - 1
        
        If IsNotBetween(FlagID, #METHOD_FLAG_IDENTITY, #METHOD_FLAG_UNFORMAT) And IsNotBetween(FlagID, #METHOD_FLAG_DATABASE_CREATE_TABLES, #METHOD_FLAG_DATABASE_TABLES_TO) And FlagID <> #METHOD_FLAG_SPECIAL
          
          Instance\MethodFlags[FlagID] = ReadPreferenceLong(Instance\MethodPrefKey[FlagID], 0)
          
          If FlagID = #METHOD_FLAG_ENCODED_READ_FILE
            Field::CurrentFileModuleName(0, ReadPreferenceString("EncodedModuleName", "ERROR"))
          EndIf
          
          If FlagID = #METHOD_FLAG_CRYPTED_READ_FILE
            Field::CurrentFileModuleName(1, ReadPreferenceString("CryptedModuleName", "ERROR"))
          EndIf
          
        EndIf
        
      Next
      
      ClosePreferences()
      
      To_GUI()
      
    EndIf
    
  EndProcedure
  
  Procedure SaveSourceCode(FileName.s)
    
    FileID = CreateFile(#PB_Any, FileName)
    
    If IsFile(FileID)
      
      WriteStringFormat(FileID, #PB_UTF8)
      
      Max = CountGadgetItems(Instance\EditorGadget[3]) - 1
      
      For ItemID = 0 To Max
        WriteStringN(FileID, GetGadgetItemText(Instance\EditorGadget[3], ItemID))
      Next
      
      CloseFile(FileID)
      
      SetFileDate(Filename, #PB_Date_Created, Date())
      SetFileDate(Filename, #PB_Date_Modified, Date())
      SetFileDate(Filename, #PB_Date_Accessed, Date())
      
    EndIf
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.62 (Linux - x64)
; Folding = -Cw5
; EnableXP
; CompileSourceDirectory